node 
{
stage('codeCheckout') {
git 'https://github.com/balpreetsingh18/spring3hibernate'
}


stage('codeStability') {
sh 'mvn compile'
    
}


 stage('build') {
        def stages = [:]
        stages["Code Quality Analysis"] = { 
stage('codeQualityAnalyis') {
sh ' mvn checkstyle:checkstyle'
recordIssues(tools: [checkStyle(pattern: '**/checkstyle-result.xml')])
} 
        }
         stages["Code Coverage Cobertura"] = {
stage('codeCoverage') {
sh 'mvn cobertura:cobertura'
cobertura autoUpdateHealth: false, autoUpdateStability: false, coberturaReportFile: '**/target/site/cobertura/coverage.xml', conditionalCoverageTargets: '70, 0, 0', failUnhealthy: false, failUnstable: false, lineCoverageTargets: '80, 0, 0', maxNumberOfBuilds: 0, methodCoverageTargets: '80, 0, 0', onlyStable: false, sourceEncoding: 'ASCII', zoomCoverageChart: false
}

        }

        parallel(stages)
    }



stage('archiveArtifacts') {

sh 'mvn  install'
archive '**/*.war'
slackSend channel: '#ghatak ', message: 'build successful'
mail bcc: '', body: 'Build Was successful', cc: '', from: '', replyTo: '', subject: 'Build Result', to: 'balpreet.singh@mygurukulam.org'
nexusArtifactUploader artifacts: [[artifactId: 'Spring3Hibernate', classifier: '', file: '/var/lib/jenkins/workspace/JenkinsAssignment3/target/Spring3HibernateApp.war', type: 'war']], credentialsId: 'nexus-jenkins', groupId: 'spring3hibernate', nexusUrl: 'localhost:8081', nexusVersion: 'nexus3', protocol: 'http', repository: 'maven-snapshots', version: '1.0-SNAPSHOT'
}
}
